import {
  transformDefineModel
} from "./chunk-A5WRWEWP.mjs";
import {
  emitHelperCode,
  emitHelperId
} from "./chunk-EKHIZ4GK.mjs";

// src/index.ts
import { createUnplugin } from "unplugin";
import { createFilter } from "@rollup/pluginutils";
function resolveOption(options) {
  return {
    include: [/\.vue$/, /\.setup\.[cm]?[jt]sx?/],
    version: 3,
    ...options
  };
}
var name = "unplugin-vue-define-model";
var src_default = createUnplugin((userOptions = {}) => {
  const options = resolveOption(userOptions);
  const filter = createFilter(options.include, options.exclude);
  return {
    name,
    enforce: "pre",
    resolveId(id) {
      if (id === emitHelperId)
        return id;
    },
    load(id) {
      if (id === emitHelperId)
        return emitHelperCode;
    },
    transformInclude(id) {
      return filter(id);
    },
    transform(code, id) {
      try {
        return transformDefineModel(code, id, options.version);
      } catch (err) {
        this.error(`${name} ${err}`);
      }
    }
  };
});

export {
  src_default
};
